package com.gic.store.service.impl;

import com.gic.store.dao.mapper.TabStoreBusinessTimeMapper;
import com.gic.store.dto.StoreBusinessTimeDTO;
import com.gic.store.entity.TabStoreBusinessTime;
import com.gic.store.service.StoreBusinessTimeService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * @author zhiwj
 * @date 2019/6/28
 */
@Service
public class StoreBusinessTimeServiceImpl implements StoreBusinessTimeService {

    @Autowired
    TabStoreBusinessTimeMapper tabStoreBusinessTimeMapper;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void editStoreBusinessTime(Integer enterpriseId, Integer storeId, List<StoreBusinessTimeDTO> businessTimeList, List<Integer> delBusinessTimes) {
        if (CollectionUtils.isNotEmpty(delBusinessTimes)) {
            for (Integer delId : delBusinessTimes) {
                tabStoreBusinessTimeMapper.deleteByPrimaryKey(delId);
            }
        }
        if(CollectionUtils.isNotEmpty(businessTimeList)) {
            for (StoreBusinessTimeDTO storeBusinessTimeDTO : businessTimeList) {
                TabStoreBusinessTime businessTime = new TabStoreBusinessTime();
                businessTime.setStoreBusinessTimeId(storeBusinessTimeDTO.getStoreBusinessTimeId());
                businessTime.setWeekday(storeBusinessTimeDTO.getWeekday());
                businessTime.setOpenTime(storeBusinessTimeDTO.getOpenTime());
                businessTime.setCloseTime(storeBusinessTimeDTO.getCloseTime());
                businessTime.setStoreId(storeId);
                if (storeBusinessTimeDTO.getStoreBusinessTimeId() == null) {
                    businessTime.setCreateTime(new Date());
                    tabStoreBusinessTimeMapper.insertSelective(businessTime);
                } else {
                    tabStoreBusinessTimeMapper.updateByPrimaryKeySelective(businessTime);
                }
            }
        }
    }

    @Override
    public List<TabStoreBusinessTime> listBusinessTime(Integer storeId) {
        return tabStoreBusinessTimeMapper.listBusinessTime( storeId);
    }
}
